/*
 * Copyright (c) 2018, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
 * All rights reserved.
 */
/*
 * This file is part of X2C. http://x2c.lcm.at/
 * $LastChangedRevision: 2159 $
 * $LastChangedDate:: 2021-03-22 17:32:11 +0100#$
 */
/* USERCODE-BEGIN:Description                                                                                         */
/* Description: */
/* USERCODE-END:Description                                                                                           */
#ifndef BANDPASSBIQ_FIP16_H
#define BANDPASSBIQ_FIP16_H

#ifdef __cplusplus
extern "C" {
#endif

#include "CommonFcts.h"

#if !defined(BANDPASSBIQ_FIP16_ISLINKED)
#define BANDPASSBIQ_FIP16_ID ((uint16)8161)

typedef struct {
    uint16          ID;
    int16           *In;
    int16           Out;
    int16           b0;
    int16           b1;
    int16           b2;
    int16           a1;
    int16           a2;
    int8            sfrb0;
    int8            sfrb1;
    int8            sfrb2;
    int8            sfra1;
    int8            sfra2;
    int16           in_old;
    int16           in_veryold;
    int16           out_old;
    int16           out_veryold;
} BANDPASSBIQ_FIP16;

#define BANDPASSBIQ_FIP16_FUNCTIONS { \
    BANDPASSBIQ_FIP16_ID, \
    (void (*)(void*))BandpassBiQ_FiP16_Update, \
    (void (*)(void*))BandpassBiQ_FiP16_Init, \
    (tLoadImplementationParameter)BandpassBiQ_FiP16_Load, \
    (tSaveImplementationParameter)BandpassBiQ_FiP16_Save, \
    (void* (*)(const void*, uint16))BandpassBiQ_FiP16_GetAddress }

/**********************************************************************************************************************/
/** Public prototypes                                                                                                **/
/**********************************************************************************************************************/
void BandpassBiQ_FiP16_Update(BANDPASSBIQ_FIP16 *pTBandpassBiQ_FiP16);
void BandpassBiQ_FiP16_Init(BANDPASSBIQ_FIP16 *pTBandpassBiQ_FiP16);
uint8 BandpassBiQ_FiP16_Load(const BANDPASSBIQ_FIP16 *pTBandpassBiQ_FiP16, uint8 data[], uint16 *dataLength, uint16 maxSize);
uint8 BandpassBiQ_FiP16_Save(BANDPASSBIQ_FIP16 *pTBandpassBiQ_FiP16, const uint8 data[], uint16 dataLength);
void* BandpassBiQ_FiP16_GetAddress(const BANDPASSBIQ_FIP16 *block, uint16 elementId);

#endif

#ifdef __cplusplus
}
#endif

#endif
